/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"time"
)

// checks if the ConversationCustomData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConversationCustomData{}

// ConversationCustomData struct for ConversationCustomData
type ConversationCustomData struct {
	Locale string `json:"locale"`
	TransactionId string `json:"transaction_id"`
	Categories *map[string]time.Time `json:"categories,omitempty"`
}

// NewConversationCustomData instantiates a new ConversationCustomData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversationCustomData(locale string, transactionId string) *ConversationCustomData {
	this := ConversationCustomData{}
	this.Locale = locale
	this.TransactionId = transactionId
	return &this
}

// NewConversationCustomDataWithDefaults instantiates a new ConversationCustomData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationCustomDataWithDefaults() *ConversationCustomData {
	this := ConversationCustomData{}
	return &this
}

// GetLocale returns the Locale field value
func (o *ConversationCustomData) GetLocale() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Locale
}

// GetLocaleOk returns a tuple with the Locale field value
// and a boolean to check if the value has been set.
func (o *ConversationCustomData) GetLocaleOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Locale, true
}

// SetLocale sets field value
func (o *ConversationCustomData) SetLocale(v string) {
	o.Locale = v
}

// GetTransactionId returns the TransactionId field value
func (o *ConversationCustomData) GetTransactionId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TransactionId
}

// GetTransactionIdOk returns a tuple with the TransactionId field value
// and a boolean to check if the value has been set.
func (o *ConversationCustomData) GetTransactionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TransactionId, true
}

// SetTransactionId sets field value
func (o *ConversationCustomData) SetTransactionId(v string) {
	o.TransactionId = v
}

// GetCategories returns the Categories field value if set, zero value otherwise.
func (o *ConversationCustomData) GetCategories() map[string]time.Time {
	if o == nil || IsNil(o.Categories) {
		var ret map[string]time.Time
		return ret
	}
	return *o.Categories
}

// GetCategoriesOk returns a tuple with the Categories field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationCustomData) GetCategoriesOk() (*map[string]time.Time, bool) {
	if o == nil || IsNil(o.Categories) {
		return nil, false
	}
	return o.Categories, true
}

// HasCategories returns a boolean if a field has been set.
func (o *ConversationCustomData) HasCategories() bool {
	if o != nil && !IsNil(o.Categories) {
		return true
	}

	return false
}

// SetCategories gets a reference to the given map[string]time.Time and assigns it to the Categories field.
func (o *ConversationCustomData) SetCategories(v map[string]time.Time) {
	o.Categories = &v
}

func (o ConversationCustomData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConversationCustomData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["locale"] = o.Locale
	toSerialize["transaction_id"] = o.TransactionId
	if !IsNil(o.Categories) {
		toSerialize["categories"] = o.Categories
	}
	return toSerialize, nil
}

type NullableConversationCustomData struct {
	value *ConversationCustomData
	isSet bool
}

func (v NullableConversationCustomData) Get() *ConversationCustomData {
	return v.value
}

func (v *NullableConversationCustomData) Set(val *ConversationCustomData) {
	v.value = val
	v.isSet = true
}

func (v NullableConversationCustomData) IsSet() bool {
	return v.isSet
}

func (v *NullableConversationCustomData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversationCustomData(val *ConversationCustomData) *NullableConversationCustomData {
	return &NullableConversationCustomData{value: val, isSet: true}
}

func (v NullableConversationCustomData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversationCustomData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


